<?php

declare(strict_types=1);

namespace hood\vk\api;

use Exception;
use hood\vk\robots\robot;

/**
 * Вложения
 */
class attachments
{
    /**
     * @var array $attachments Вложения
     */
    protected array $attachments = [];

    /**
     * Конструктор
     * 
     * @var robot $robot Робот
     */
    public function __construct(
        protected robot $robot
    ) {
    }

    /**
     * Записать вложения
     * 
     * @param string|array $attachments Вложения
     * 
     * @return self
     */
    public function attachment(string ...$attachments): self
    {
        // Если вложений больше 10
        if (count($this->attachments) + count($attachments) > 10) {
            throw new Exception('Превышен лимит вложений (10)');
        }

        // Запись вложений
        $this->attachments = array_merge($this->attachments, $attachments);

        return $this;
    }

    /**
     * Очистить вложения
     */
    public function Clear(): self
    {
        // Очистка вложений
        $this->attachments = [];

        return $this;
    }

    /**
     * Прочитать свойство
     *
     * @param string $name Название
     * 
     * @return mixed
     */
    public function __get(string $name): mixed
    {
        return match ($name) {
            'attachments' => $this->attachments,
            default => throw new Exception('Свойство не найдено: ' . $name)
        };
    }
}
