<?php

declare(strict_types=1);

namespace hood\vk\api\methods;

use hood\vk\robots\robot,
    hood\vk\robots\group;

use hood\accounts\vk as account;

use Exception;

/**
 * Фотографии (изображения)
 *
<<<<<<< HEAD
 * public static function put(RobotAbstract $from, int $to, string $message, int $mode = 2) Отправить сообщение
=======
 * @method public static function put(RobotAbstract $from, int $to, string $message, int $mode = 2) Отправить сообщение
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
 *
 * @see https://vk.com/dev/photos.getUploadServer
 * @see https://vk.com/dev/messages.getById
 *
 * @package hood\vk\api\methods
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
 *
 * @todo Добавить обработку ошибок ($request['errors];)
 */
final class photos extends method
{
    /**
     * $url
     */
    protected $url;

    /**
<<<<<<< HEAD
     * Сохранить
     *
     * $robot Робот
     * $album_id Альбом
     * $group_id Группа
     * $caption Описание
     * $latitude Географическая широта (-90, 90)
     * $longitude Географическая долгота (-180, 180)
=======
     * Создать сообщение
     *
     * @param robot $robot Робот
     */
    public function __construct(
        protected robot $robot
    ) {
    }

    /**
     * Сохранить
     *
     * @param robot $robot Робот
     * @param int $album_id Альбом
     * @param int|null $group_id Группа
     * @param string|null $caption Описание
     * @param float|null $latitude Географическая широта (-90, 90)
     * @param float|null $longitude Географическая долгота (-180, 180)
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     *
     * @see https://vk.com/dev/photos.save
     *
     * @return array|null Ответ сервера
     */
    public static function save(robot $robot, int $album_id, array $images, string $upload_url = null, string|null $caption = null, int|null $group_id = null, float|null $latitude = null, float|null $longitude = null): ?array
    {
        if (isset($robot->account)) {
            // Если инициализирован аккаунт

            // Порядок инициализации ДОЛЖЕН соответствовать порядку в документации

            // Ключ
            $settings['access_token'] = $robot->account->key;

            // Версия API
            $settings['v'] = $robot->version;

            // Альбом
            $settings['album_id'] = $album_id;

            // Группа
            if (isset($group_id)) {
                $settings['group_id'] = $group_id;
            }

            //загрузить
            $upload = self::uploadMessage($robot, $upload_url, ...$images);

            // Сервер
            $settings['server'] = $upload['server'];

            // Изображения
            $settings['photos_list'] = $upload['photos_list'];

            // Хеш
            $settings['hash'] = $upload['hash'];

            // Широта
            if (isset($latitude)) {
                $settings['latitude'] = $latitude;
            }

            // Долгота
            if (isset($longitude)) {
                $settings['longitude'] = $longitude;
            }

            // Описание
            if (isset($caption)) {
                $settings['caption'] = $caption;
            }

            return (array) $robot->browser->api('photos.save', $settings);
        }

        throw new Exception('Аккаунт не инициализирован');
    }

    /**
     * Загрузить
     *
     * @param Type $var
<<<<<<< HEAD
=======
     * @return void
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public static function upload(string ...$images): void
    {
        if (count($images) > 5) {
            throw new Exception('Запрещено отправлять более 5 фотографий');
        }
    }

    /**
     * загрузить
     */
    public static function uploadMessage(robot $robot, string $upload_url, string ...$images)
    {
        return $robot->browser->api($upload_url, ...$images);
    }

    /**
     * Получить сервер для загрузки изображений
     *
<<<<<<< HEAD
     * $robot Робот
     * $album_id Альбом
     * $group_id Группа
=======
     * @param robot $robot Робот
     * @param int|null $album_id Альбом
     * @param int|group|null $group_id Группа
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     *
     * @see https://vk.com/dev/photos.getUploadServer
     *
     * @return array|null Ответ сервера
     */
    public static function getUploadServer(robot $robot, int|null $album_id = null, int|group|null $group_id = null): ?array
    {
        if (isset($robot->account)) {
            // Если инициализирован аккаунт

            // Порядок инициализации ДОЛЖЕН соответствовать порядку в документации API ВКонтакте

            // Ключ
            $settings['access_token'] = $robot->account->key;

            // Версия API
            $settings['v'] = $robot->version;

            // Альбом
            match (true) {
                isset($album_id) => $settings['album_id'] = $album_id,
                default => $settings['album_id'] = self::getAlbums($robot)
            };

            // Группа
            if (isset($group_id)) {
                // При неудачном чтении воспринимать как целочисленное атомарное значение
                $settings['group_id'] = $group_id->id ?? $group_id;
            }

            return (array) $robot->browser->api('photos.getUploadServer', $settings);
        }

        throw new Exception('Аккаунт не инициализирован');
    }

    /**
     * Получить альбомы
     *
<<<<<<< HEAD
     * $robot Робот
     * $album_ids = null Идентификаторы альбомов
     * $offset = null Смещение для выборки подмножества
     * $count = null Количество для возврата
     * $need_system = null Активация возврата системных альбомов
     * $need_covers = null Активация возврата поля с обложкой альбома
     * $photo_sizes = null Активация специального формата размеров фотографий
     *
     * @see https://vk.com/dev/photos.getUploadServer
     *
     * Ответ сервера
=======
     * @param robot $robot Робот
     * @param array $album_ids = null Идентификаторы альбомов
     * @param int $offset = null Смещение для выборки подмножества
     * @param int $count = null Количество для возврата
     * @param bool $need_system = null Активация возврата системных альбомов
     * @param bool $need_covers = null Активация возврата поля с обложкой альбома
     * @param bool $photo_sizes = null Активация специального формата размеров фотографий
     *
     * @see https://vk.com/dev/photos.getUploadServer
     *
     * @return array Ответ сервера
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public static function getAlbums(robot $robot, array $album_ids = null, int $offset = null, int $count = null, bool $need_system = null, bool $need_covers = null, bool $photo_sizes = null): array
    {
        // Настройки
        $settings['access_token'] = $robot->key;
        $settings['v'] = $robot->version;
        $settings['owner_id'] = $robot->id;
        if (isset($album_ids)) {
            $settings['album_ids'] = implode(',', $album_ids);
        }
        if (isset($offset)) {
            $settings['offset'] = $offset;
        }
        if (isset($count)) {
            $settings['count'] = $count;
        }
        if (isset($need_system)) {
            $settings['need_system'] = (int) $need_system;
        }
        if (isset($need_covers)) {
            $settings['need_covers'] = (int) $need_covers;
        }
        if (isset($photo_sizes)) {
            $settings['photo_sizes'] = (int) $photo_sizes;
        }

        // Запрос
        $request = $robot->browser->request('POST', 'photos.getUploadServer', $settings)->getBody()->getContents();

        return (array) $request;
    }

    /** 
<<<<<<< HEAD
    * загрузить фото и получить его id
    *
    * $robot робот
    *
    * $img фото
    */

    public function sex(robot $robot, $img)
    {
        if (!isset($this->url)) {

            // Получить адрес сервера для загрузки фотографии в личное сообщение
            $this->url = json_decode($robot->browser->request('POST', 'photos.getMessagesUploadServer', [
                'form_params' => [
                    'group_id'      => $robot->id,
                    'v'             => $robot->version,
                    'access_token'  => $robot->key,
                    'peer_id' => 0
                ]
            ])->getBody()->getContents())->response->upload_url;
        }

        //загрузить
        $response = json_decode($robot->browser->request('POST', $this->url, [
=======
     * Загрузить фото и получить его id
     *
     * $robot робот
     *
     * $img фото
     */

    public function getPhoto($img)
    {
        // Реиницилазиция
        $this->robot->api->reinit();

        // Идентификатор группы
        $this->robot->api['group_id'] = $this->robot->id;

        // Идентификатор назначения (0 Для ботов)
        $this->robot->api['peer_id'] = 0;

        // Получить адрес сервера для загрузки фотографии в личное сообщение
        $url = json_decode($this->robot->browser->request('POST', 'photos.getMessagesUploadServer', [
            'form_params' => $this->robot->api['settings']
        ])->getBody()->getContents())->response->upload_url;

        // Загрузить фото
        $response = json_decode($this->robot->browser->request('POST', $url, [
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
            'multipart' => [
                [
                    'Content-type' => 'multipart/form-data',
                    'name' => 'photo',
                    'contents' => $img
                ]
            ]
        ])->getBody()->getContents());

<<<<<<< HEAD
        //сохранить
        $response = json_decode($robot->browser->request('POST', 'photos.saveMessagesPhoto', [
            'form_params' => [
                'group_id'      => $robot->id,
                'v'             => $robot->version,
                'access_token'  => $robot->key,
                'server' =>  $response->server,
                'photo' => $response->photo,
                'hash' => $response->hash
            ]
        ])->getBody()->getContents());

        return 'photo' . $response->response[0]->owner_id . '_' . $response->response[0]->id;
    }
}
=======

        // Реинициализация
        $this->robot->api->reinit();

        // Идентификатор группы
        $this->robot->api['group_id'] = $this->robot->id;


        // Сервер
        $this->robot->api['server'] = $response->server;

        // Фото
        $this->robot->api['photo'] = $response->photo;

        // Хэш
        $this->robot->api['hash'] = $response->hash;

        // Сохранить фото
        $response = json_decode($this->robot->browser->request('POST', 'photos.saveMessagesPhoto', [
            'form_params' => $this->robot->api['settings']
        ])->getBody()->getContents());

        // Ссылка на фото
        if (isset($response->response)) {
            return 'photo' . $response->response[0]->owner_id . '_' . $response->response[0]->id;
        } else {
            throw new Exception('Фото не загружено');
        }
    }
}
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
