<?php

declare(strict_types=1);

namespace hood\vk;

use Exception;
use hood\vk\loggers\jasmo,
    hood\vk\traits\singleton,
    hood\vk\robots\robot;

/**
 * Ядро
 *
<<<<<<< HEAD
 * $robots Количество роботов
 * $timezone Временная зона (журналирование)
 * $path Пути (архитектура проекта)
 *
 * protected static function __construct() Инициализация
 * public static function init() Запуск инициализации или получение инстанции
 * public public function build() Сборщик
 * public function set($id, $value) Запись в реестр
 * public function get($id = null) Чтение из реестра
=======
 * @property-read int $robots Количество роботов
 * @property string $timezone Временная зона (журналирование)
 * @property array $path Пути (архитектура проекта)
 *
 * @method protected static function __construct() Инициализация
 * @method public static function init() Запуск инициализации или получение инстанции
 * @method public public function build() Сборщик
 * @method public function set($id, $value) Запись в реестр
 * @method public function get($id = null) Чтение из реестра
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
 *
 * @package VK
 * @author Арсен Мирзаев <red@hood.su>
 */
final class core
{
    use singleton;

<<<<<<< HEAD
    /**
     * Счётчик роботов
=======
   /**
     * Счётчик роботов
     *
     * @var int
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private int $robots = 0;

    /**
     * Реестр роботов
<<<<<<< HEAD
=======
     *
     * @var array
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private array $registry = [];

    /**
     * Временная зона
     *
     * Используется в логировании
<<<<<<< HEAD
=======
     *
     * @var string
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private string $timezone;

    /**
     * Путь до корня проекта
<<<<<<< HEAD
=======
     *
     * @var string
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private string $path_root;

    /**
     * Путь до папки журналов
<<<<<<< HEAD
=======
     *
     * @var string
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private string $path_logs;

    /**
     * Путь до временной папки
<<<<<<< HEAD
=======
     *
     * @var string
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private string $path_temp;

    /**
     * Журналист
     *
<<<<<<< HEAD
     * $file Файл для журналирования
=======
     * @param string $file Файл для журналирования
     *
     * @return self
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     *
     * @todo Добавить установку иного журналиста по спецификации PSR-3
     * @todo Более гибкое журналирование
     */
    public function log(string $file = null): self
    {
        // Инициализация журналиста (требует переработки)
        jasmo::init()::post($file)::postErrorHandler()::postShutdownHandler();

        return $this;
    }

    /**
     * Записать в реестр
     *
<<<<<<< HEAD
     * $id Идентификатор
     * $robot робот
     *
     * @see hood\vk\traits\registry Модификация метода
=======
     * @param int $id
     * @param robot $robot
     *
     * @see hood\vk\traits\registry Модификация метода
     *
     * @return void
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function set(int $id, robot $robot): void
    {
        // if (empty($this->registry[$id])) {
        //     // Если нет сессий, то инициализировать
        //     $this->registry[$id] = [];
        // }

        // Создать новую сессию и обновить счётчик роботов
        $this->registry[$id][++$this->robots] = $robot;
    }

    /**
     * Прочитать из реестра
     *
     * Если не передать идентификатор, то вернёт все значения
     *
<<<<<<< HEAD
     * $id Идентификатор
     * $session Сессия
     *
     * @see hood\vk\traits\registry Модификация метода
=======
     * @param int|null $id Идентификатор
     * @param int|null $session Сессия
     *
     * @see hood\vk\traits\registry Модификация метода
     *
     * @return mixed
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function get(int|null $id = null, int|null $session = null): mixed
    {
        if (isset($id) && array_key_exists($id, $this->registry)) {
            // Робот передан и найден
            if (isset($session) && array_key_exists($session, $this->registry[$id])) {
                // Сессия робота передана и найдена
                return $this->registry[$id][$session];
            }
            return $this->registry[$id];
        }
        return $this->registry;
    }

    /**
     * Удалить из реестра
     *
<<<<<<< HEAD
     * $id Идентификатор
     * $session Сессия
     *
     * @see hood\vk\traits\registry Модификация метода
=======
     * @param int|null $id Идентификатор
     * @param int|null $session Сессия
     *
     * @see hood\vk\traits\registry Модификация метода
     *
     * @return void
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function delete(int|null $id = null, int|null $session = null): void
    {
        if (isset($id)) {
            // Робот передан

            if (!array_key_exists($id, $this->registry)) {
                throw new Exception('Робот не найден');
            }

            if (isset($session)) {
                // Сессия передана

                if (!array_key_exists($session, $this->registry[$id])) {
                    throw new Exception('Сессия не найдена');
                }

                // Счётчик роботов
                --$this->robots;

                // Удаление сессии
                unset($this->registry[$id][$session]);

                return;
            }

            // Счётчик роботов
            $this->robots = $this->robots - count($this->registry[$id]);

            // Удаление робота и всех его сессий
            unset($this->registry[$id]);

            return;
        }

        // Удаление всех роботов и их сессий
        $this->registry = [];
    }

    /**
     * Записать свойство
     *
<<<<<<< HEAD
     * $name Название
     * $value Значение
=======
     * @param mixed $name Название
     * @param mixed $value Значение
     *
     * @return void
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __set(mixed $name, mixed $value): void
    {
        match ($name) {
            'timezone' => !isset($this->timezone) ? $this->timezone = $value : throw new Exception('Запрещено переопределять часовой пояс'),
            'path_root' => !isset($this->path_root) ? $this->path_root = $value : throw new Exception('Запрещено переопределять корневой каталог'),
            'path_logs' => !isset($this->path_logs) ? $this->path_logs = $value : throw new Exception('Запрещено переопределять каталог журналов'),
            'path_temp' => !isset($this->path_temp) ? $this->path_temp = $value : throw new Exception('Запрещено переопределять каталог временных файлов')
        };
    }

    /**
     * Прочитать свойство
<<<<<<< HEAD
     * 
     * Значение по умолчанию, есле не задано
     *
     * $name Название
=======
     *
     * @param mixed $name Название
     *
     * @return mixed
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __get(mixed $name): mixed
    {
        return match ($name) {
            'robots' => $this->robots,
            'timezone' => !isset($this->timezone) ? $this->timezone = 'Europe/Moscow' : $this->timezone,
            'path_root' => !isset($this->path_root) ? $this->path_root = dirname(__DIR__) : $this->path_root,
            'path_logs' => !isset($this->path_logs) ? $this->path_logs = $this->path_root . '/logs' : $this->path_logs,
            'path_temp' => !isset($this->path_temp) ? $this->path_root . '/temp' : $this->path_temp,
            default => null
        };
    }

    /**
     * Вызвать метод
     *
     * Ищет класс описывающий робота,
     * создаёт и возвращает его объект
     *
<<<<<<< HEAD
     * $method Метод
     * $params Параметры
=======
     * @param string $method Метод
     * @param array $params Параметры
     *
     * @return robot
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __call(string $method, array $params): robot
    {
        if (class_exists($robot = '\\hood\\vk\\robots\\' . $method)) {
            // Если найден класс реализующий запрошенного робота
            return new $robot(...$params);
        } else {
            throw new Exception('Не найден робот: ' . $method);
        }
    }
}
